"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEventBusSendMessagesActionProcessor = void 0;
const quidproquo_config_aws_1 = require("quidproquo-config-aws");
const quidproquo_core_1 = require("quidproquo-core");
const awsNamingUtils_1 = require("../../../awsNamingUtils");
const publishMessage_1 = require("../../../logic/sns/publishMessage");
const getProcessEventBusSendMessage = (qpqConfig) => {
    return (_a, session_1) => __awaiter(void 0, [_a, session_1], void 0, function* ({ eventBusName, eventBusMessages, context, }, session) {
        var _b, _c, _d, _e, _f;
        const region = quidproquo_config_aws_1.qpqConfigAwsUtils.getApplicationModuleDeployRegion(qpqConfig);
        const eventBusConfig = quidproquo_core_1.qpqCoreUtils.getEventBusConfigByName(eventBusName, qpqConfig);
        if (!eventBusConfig) {
            return (0, quidproquo_core_1.actionResultError)(quidproquo_core_1.ErrorTypeEnum.NotFound, `Event bus ${eventBusName} not found`);
        }
        const topicArn = (0, awsNamingUtils_1.getEventBusSnsTopicArn)(((_b = eventBusConfig.owner) === null || _b === void 0 ? void 0 : _b.resourceNameOverride) || eventBusName, qpqConfig, ((_c = eventBusConfig.owner) === null || _c === void 0 ? void 0 : _c.module) || quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig), ((_d = eventBusConfig.owner) === null || _d === void 0 ? void 0 : _d.environment) || quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig), ((_e = eventBusConfig.owner) === null || _e === void 0 ? void 0 : _e.application) || quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig), ((_f = eventBusConfig.owner) === null || _f === void 0 ? void 0 : _f.feature) || quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig));
        yield (0, publishMessage_1.publishMessage)(topicArn, region, eventBusMessages.map((message) => {
            const eventBusMessageWithSession = Object.assign(Object.assign({}, message), { storySession: Object.assign(Object.assign({}, session), { context }) });
            return JSON.stringify(eventBusMessageWithSession);
        }));
        return (0, quidproquo_core_1.actionResult)(void 0);
    });
};
const getEventBusSendMessagesActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.EventBusActionType.SendMessages]: getProcessEventBusSendMessage(qpqConfig),
    });
});
exports.getEventBusSendMessagesActionProcessor = getEventBusSendMessagesActionProcessor;
